SystemOrganization addCategory: #AttractorModelisation!

DynamicComposableModel subclass: #UISecondVersion
	instanceVariableNames: 'mainView xtview ytview ztview plus slider lcolor varValues minus attr precisionStep secondaryViews odesInput rec odesValues sizeOfUI sliderSigma sliderRho sliderBeta sliderX sliderY sliderZ'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!UISecondVersion commentStamp: '<historical>' prior: 0!
I am the new version!

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/23/2017 15:09'!
initialize
	self initialize: Attractor new! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:46'!
initialize: attrIn
	attr := attrIn.
	rec := Reconstructor new.
	super initialize.
	self initializeWidgets.
	self extent: 1250 @ 750.
			! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/20/2017 19:32'!
initializeWidgets

	self instantiateModels: #(
		mainView RoassalModel
		xtview RoassalModel
		ytview RoassalModel
		ztview RoassalModel
		plus ButtonModel 
		sliderSigma SliderModel
		sliderRho SliderModel
		sliderBeta SliderModel
		sliderX SliderModel
		sliderY SliderModel
		sliderZ SliderModel
		lcolor CheckBoxModel
		varValues LabelModel
		minus ButtonModel
		precisionStep TextInputFieldModel
		odesValue LabelModel
		odesInput TextInputFieldModel
		sizeOfUI LabelModel
		).
	layout := (SpecLayout composed
	newRow:[ :firstCol|
		firstCol 
		newColumn: [ :bCol | bCol 
				add: #odesInput ;
				newRow: [:r1 | r1  add: #odesValues]height: 25 ];
		newColumn: [ :col |
			col
				newRow: [:r | r add: #mainView; newColumn: [:c | c add: #sliderSigma; add: #sliderRho; add: #sliderBeta;
																					add: #sliderX ;add:#sliderY ; add:#sliderZ]];
			
				newRow:[:c | c 	add: #xtview; addSplitter;
									add: #ytview; addSplitter;
									add: #ztview];
				addSplitter;
				newRow: [:c | c add: #sizeOfUI; add: #varValues;add: #lcolor] height:25 ;
				newColumn: [:aCol| aCol
					newRow: [ :aRow | aRow  
					add: #minus ;
					add: #plus;
					add: #precisionStep ] height: 25 ]]
			
		];
	yourself).

	"Odes"
	odesInput := TextInputFieldModel new.
	odesInput beForCode.
	self odesInput entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:sigmaRhoBeta :xyz| your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:sigmaRhoBeta :xyz|',text,'] value:#(1 2 3) value:#(1 2 3)')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:sigmaRhoBeta :xyz|',text,'] value:#(1 2 3) value:#(1 2 3) ') isNumber ifTrue: [ rec odes:(Compiler evaluate: '[',text,']')]. self refresh ]   ] .
	
	odesValues := LabelModel new.
	self odesValues label:'odes= ',((rec odes) asString) .
	
	"Views"
	
	
	mainView := RoassalModel new.
	xtview := RoassalModel new.
	ytview := RoassalModel new.
	ztview := RoassalModel new.
	self mainView script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt: 4).
		canvas camera focusOnCenter.
	].
	self xtview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:1) .
		canvas camera focusOnCenter.
	].
	self ytview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:2).
		canvas camera focusOnCenter.
	].
	self ztview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:3).
		canvas camera focusOnCenter.
	].

	"Sliders"
	sliderSigma :=  SliderModel new.
	sliderRho :=  SliderModel new.
	sliderBeta :=  SliderModel new.
	sliderX :=  SliderModel new.
	sliderY :=  SliderModel new.
	sliderZ :=  SliderModel new.
	self sliderSigma whenValueChangedDo: [:value |attr sigma: value. self refresh]
					;min:0;max:20;label:'0<=sigma<=20'.
	self sliderRho whenValueChangedDo: [:value |attr p: value. self refresh]
					;min:0;max:10;label:'0<=rho<=10';quantum: 0.2.
	self sliderBeta whenValueChangedDo: [:value |attr beta: value. self refresh]
					;min:0;max:40;label:'0<=beta<=20'.
		"those are to change the initial state. How can I change it inside Attractor ?"
	self sliderX whenValueChangedDo: [:value | value. self refresh]
					;min:0;max:10;label:'0<=x<=10'.
	self sliderY whenValueChangedDo: [:value | value. self refresh]
					;min:0;max:10;label:'0<=y<=10'.
	self sliderZ whenValueChangedDo: [:value | value. self refresh]
					;min:0;max:10;label:'0<=z<=10'.
					
	"feedback values"
	varValues := LabelModel new.
	self varValues label:'sigma=',(attr sigma asString) ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'",'   p =',(attr p asString ),'   beta =',(attr beta asString ) .
	
	"Modifiers"
	precisionStep := TextInputFieldModel new.
	self precisionStep entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Precision (Integer)';
		whenTextChanged: [:text| (text asInteger) isNil not ifTrue: [attr precision: (text asInteger)]. self refresh ].
	self minus label: 'zoom--'; state: false; 
			action: [attr view canvas camera scale: attr view canvas camera scale - 20.
	    attr view signalUpdate. self refresh].
	self plus label: 'r++'; state: false; 
			action: [attr r: attr r +1.  self refresh ].

	lcolor := CheckBoxModel new.
	self lcolor whenChangedDo: [:bool| bool 
		ifTrue: [attr ds connectColor: Color green . self refresh ] 
		ifFalse:  [attr ds disconnect. attr ds connectColor: Color transparent. self refresh ]] .

	
	
	"Testers"
	sizeOfUI := LabelModel new.
	self sizeOfUI label:'UIsize= ',((self sizeInMemory ) asString) .! !

!UISecondVersion methodsFor: 'accessing' stamp: 'antoineZim 2/23/2017 16:34'!
layout
	^layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:38'!
lcolor
	^lcolor! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/28/2017 11:44'!
mainView
	^mainView! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 13:28'!
odesInput
	^odesInput ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 14:42'!
odesValues
	^odesValues! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/23/2017 16:40'!
openView
	
	self openWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 20:43'!
precisionStep
	^precisionStep! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 3/17/2017 19:03'!
refresh
"TODO: find another solution to remake the model attr"
"attr refresh -> not working"
"attr view refresh -> not working"
	attr rebuild .
	self varValues label:'sigma=',(attr sigma asString) ,'   rho =',(attr p asString ),'   beta =',(attr beta asString ) ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'".
	self odesValues label: 'odes= ',((rec odes) asString).
	self sizeOfUI label: 'sizeUI',((self sizeInMemory ) asString).
	self needRebuild: false.
	self buildWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:10'!
sizeOfUI
	^sizeOfUI ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderBeta
	^sliderBeta ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderRho
	^sliderRho! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderSigma
	^sliderSigma! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderX
	^sliderX! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderY
	^sliderY! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:24'!
sliderZ
	^sliderZ! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/27/2017 16:37'!
varValues
	^varValues! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
xtview
	^xtview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
ytview
	^ytview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:38'!
ztview
	^ztview! !

Object subclass: #Attractor
	instanceVariableNames: 'sigma r p dt initState values b attrView xValues yValues zValues graphList viewList ds precision xSteppedValues ySteppedValues zSteppedValues rho beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Attractor commentStamp: '<historical>' prior: 0!
I am an empirical model of the Lorenz Attractor.!

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/17/2017 18:55'!
beta
	^r! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/17/2017 18:55'!
beta: val
	r := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews 
	^(self buildAllViews: graphList)! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews: graphCollection
	|newViewList|
	newViewList := OrderedCollection new.
	graphCollection do: [ :eachB | newViewList add: (self buildView: eachB) ].
	^newViewList! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher

	b := RTGrapher new.
	ds := RTData new.
	ds dotShape ellipse size: 1; color: (Color blue).
	ds points: values.
	ds x: [:val | val at: 1]; y: [:val| val at: 2].
	b add: ds.
	b build.
	^b! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: valueList
	|ab ads|
	ab := RTGrapher new.
	graphList add: ab.
	ads := RTData new.
	ads dotShape ellipse size: 1.
	ads points: valueList .
	ads connectColor: Color red.
	"ads y: #yourself."
	ab add: ads.
	ab build.
	! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: anOrderedCollection withColor: color
	|ab ads|
	ab := RTGrapher new.
	ads := RTData new.
	ads dotShape ellipse size: 1; color: (Color blue).
	ads points: anOrderedCollection.
	ads connectColor: Color color.
	ads y: #yourself.
	ab add: ads.
	ab shouldUseNiceLabels: true.
	
	ab build.
	graphList add: ab! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:27'!
buildView: ab
	|aView anElementsAndEdges |
	aView := RTView new.
	aView @ RTDraggableView.

	anElementsAndEdges := ab view elements, ab view edges.
	aView addAll: anElementsAndEdges.

	
	aView canvas camera noInitializationWhenOpen.
	aView canvas camera scale: 1.5.

	^aView! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:20'!
ds
	^ds! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt
	^dt! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt: val
	dt:= val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
elements
	^(b view elements)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
graphList
	^graphList ! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
initState: val
	initState := val! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 18:56'!
initialize
	| newsigma newr newp newdt newprecision |
	
	newsigma := 10.0.
	newr := 30.0.
	newp := 8.0/3.0.
	newdt := 0.1.
	newprecision := 25.
	self initializeWithSigma: newsigma r: newr p: newp dt: newdt precision: newprecision ! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:01'!
initializeWithSigma: newsigma r: newr p: newp dt: newdt precision: newprecision
	
	self valuesBuilderWithSigma: newsigma r: newr p: newp dt: newdt precision: newprecision .
	"self halt."
	self buildRTGrapher: xSteppedValues .
	self buildRTGrapher: ySteppedValues .
	self buildRTGrapher: zSteppedValues .
	graphList add: (self buildRTGrapher).
	viewList := self buildAllViews! !

!Attractor methodsFor: 'hooks' stamp: 'antoineZim 2/28/2017 23:21'!
openRTGrapher
	b open! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
p
	^p! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/17/2017 18:52'!
p: val
	p:= val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision
	^precision! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision: val
	precision := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
r
	^r! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
r: val
	r := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/17/2017 17:00'!
rebuild
	self initializeWithSigma: sigma r: r p: p dt: dt precision: precision .


! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/17/2017 18:56'!
rho
	^p! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/17/2017 18:56'!
rho: val
	p := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma
	^sigma! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma: val
	sigma := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
values: val
	values := val
! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:22'!
valuesBuilderWithSigma: newsigma r: newr p: newp dt: newdt precision:newprecision
	| system stepper solver state |
	graphList :=OrderedCollection new.
	viewList :=OrderedCollection new.
	sigma := newsigma .
	r := newr.
	p := newp.
	dt := newdt.
	precision := newprecision.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	system := ExplicitSystem
		block:[:val :t | |dx dy dz x y z|
			x := val at: 1. y := val at: 2. z := val at: 3.
			xValues  add: x. yValues add:y. zValues add: z.
			dx := sigma * (y - x).
			dy := r * x - y - (x * z).
			dz := (-1 * p * z + (x * y)).
			{dx. dy. dz}.
			].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	state := #(10.0 10.0 10.0).
	values := (0.0 to: 100.0 by: dt) collect:[:t |
	state := stepper doStep: state time:t stepSize: dt].

	xSteppedValues:= OrderedCollection new.
	ySteppedValues:= OrderedCollection new.
	zSteppedValues:= OrderedCollection new.

	xSteppedValues addAllLast: xValues from: 1 to: xValues size  by: precision .
	ySteppedValues addAllLast: yValues from: 2 to: yValues size  by: precision .
	zSteppedValues addAllLast: zValues from: 3 to: zValues size  by: precision .! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewForGraphAt: indexInGraphList
	^((graphList at: indexInGraphList ) view)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewList
	^viewList 
	! !

Object subclass: #Reconstructor
	instanceVariableNames: 'odes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Reconstructor commentStamp: '<historical>' prior: 0!
Make the reconstruction !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/16/2017 12:58'!
generateWithData_length: data_length odes: odes state: state parameters: parameters
	|data tempState|
	tempState := state.
	data := (Array new: data_length).
	"pourquoi faire 5000 it ? pour se retrouver au milieu d une serie chrono ?"
	"1 to: 5000 do: [ :i| tempState := self rk4WithOdes: odes state: tempState parameters: parameters ]."
	1 to: data_length do: [ :i| tempState := (self rk4WithOdes: odes state: tempState parameters: parameters) ].

	(1 to: data_length do:[:i | tempState :=self rk4WithOdes: odes state: tempState parameters: parameters . data at:i put: tempState]).
	^data  
	
! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:48'!
initialize
	odes := self lorenz_odes ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:47'!
lorenz_generateWithData_length: data_length
	^(self generateWithData_length: data_length odes: self lorenz_odes state: (Array with: -8.5 with: 8.0 with: 27.0 ) parameters: (Array with: 10.0 with: 8/3.0 with: 28.0))! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/15/2017 15:03'!
lorenz_odes
	^[:sigmaRhoBeta :xyz| (Array with: (sigmaRhoBeta at: 1) * ((xyz at: 2) - (xyz at:1 )) with: (xyz at: 1) * ((sigmaRhoBeta at: 2) - (xyz at: 3)) - (xyz at: 2) with: (xyz at: 1) * (xyz at: 2) - (sigmaRhoBeta at: 3) * (xyz at: 3)) ]
! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 12:44'!
makeCompareGraphs
	| g g1 g2 g3 ds1 ds2 ds3 rec x y z |
rec := (Reconstructor new) lorenz_generateWithData_length: 10.

x := (rec collect: [ : each| each at: 1 ]).
y := (rec collect: [ : each| each at: 2 ]).
z := (rec collect: [ : each| each at: 3 ]).

g := RTMultiGrapher new.

g1 := RTGrapher new.
ds1 := RTData new.
ds1 label: 'Red'.
ds1 dotShape color: Color red.
ds1 connectColor: Color red.
ds1 points: x.
ds1 interaction highlightDataset: Color black.
g1 add: ds1.
g2 := RTGrapher new.
ds2 := RTData new.
ds2 label: 'Blue'.
ds2 dotShape color: Color blue.
ds2 connectColor: Color blue.
ds2 points: y.
ds2 interaction highlightDataset: Color purple.
g2 add: ds2.

g3 := RTGrapher new.
ds3 := RTData new.
ds3 label: 'Green'.
ds3 dotShape color: Color green.
ds3 connectColor: Color green.
ds3 points: z.
ds3 interaction highlightDataset: Color black.
g3 add: ds3.

g1 axisY
	title: 'y 1';
	color: Color red.
g2 axisY
	title: 'y 2';
	color: Color blue.
g3 	axisY
	title: 'y 3';
	color: Color green.
g add: g1.
g add: g2.
g add: g3.
g legend.
^ g! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:18'!
odes
	^odes ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:19'!
odes: o
	odes :=o! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:18'!
odesGenerateWithdata_length: data_length
	^(self generateWithData_length: data_length odes: self odes state: (Array with: -8.5 with: 8.0 with: 27.0 ) parameters: (Array with: 10.0 with: 8/3.0 with: 28.0))
	! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/15/2017 22:25'!
rk4WithOdes: odesBlock state: state parameters: parameters
	| dt k1 k2 k3 k4 |
	dt := 0.01.
	k1 := Array with: dt * ((odesBlock value: state value: parameters) at:1)
					with: dt * ((odesBlock value: state value: parameters) at:2)
					with: dt * ((odesBlock value: state value: parameters) at:3) .
					
	k2 := Array with: (dt * (odesBlock value: (state + (0.5 * k1)) value: parameters)at: 1)
					with: (dt * (odesBlock value: (state + (0.5 * k1)) value: parameters)at: 2)
					with: (dt * (odesBlock value: (state + (0.5 * k1)) value: parameters)at: 3).
					
	k3 := Array with:(dt * (odesBlock value: (state + (0.5 * k2)) value: parameters)at: 1)
					with:(dt * (odesBlock value: (state + (0.5 * k2)) value: parameters)at: 2)
					with:(dt * (odesBlock value: (state + (0.5 * k2)) value: parameters)at: 3).
					
	k4 := Array with: (dt * (odesBlock value: (state + k3) value: parameters)at:1)
					with: (dt * (odesBlock value: (state + k3) value: parameters)at:2)
					with: (dt * (odesBlock value: (state + k3) value: parameters)at:3).
	^ (state  +(k1 + (2 * k2) + (2 * k3) + k4) / 6)! !
